#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cctype>
#include <cassert>
#define Pmax 2010
#define Rmax 300
#define Cuvmes 30

using namespace std;
struct tag
{
    short int pg,rd,cv;
};

char s[Rmax],Pag[Rmax], Rand[Rmax], Cuv[Rmax],romane[10]="MDCLXVI ";

tag L[Cuvmes];

int p, r, c, P[Cuvmes], C[Cuvmes], R[Cuvmes], np, nc, nr;
int i, j, k, test, ii=1;

int cif(char x)
{
    if(x=='M') return 1000;
    if(x=='D') return 500;
    if(x=='C') return 100;
    if(x=='L') return 50;
    if(x=='X') return 10;
    if(x=='V') return 5;
    if(x=='I') return 1;
}

int NrRo(char s[])
{

    int n=strlen(s);
    int Nr=cif(s[n-1]);
    for(int i=0; i<n-1; i++)
        if (cif(s[i])>=cif(s[i+1])) Nr+=cif(s[i]);
        else Nr-=cif(s[i]);
    return Nr;
}


void PuneNr(int V[], int &n, char s[1000])
{
    char x[1000], *p;
    p=strtok(s," ");
    while (p)
    {
        strcpy(x,p);
        V[++n]=NrRo(x);
        p=strtok(NULL," ");
    }
}

bool cmp(tag a, tag b)
{
    if(a.pg < b.pg) return true;
    if(a.pg == b.pg && a.rd<b.rd) return true;
    if(a.pg == b.pg && a.rd==b.rd && a.cv<b.cv) return true;
    return false;
}

int main()
{
    freopen("nod.in", "r", stdin);
    freopen("nod.out", "w", stdout);
    scanf("%d\n", &test);
    gets(Pag);
    int x=strlen(Pag);
    for(int t=0; t<x; t++)
       assert(strchr(romane,Pag[t]));
    PuneNr(P, np, Pag);
    gets(Rand);
    x=strlen(Rand);
    for(int t=0; t<x; t++)
       assert(strchr(romane,Rand[t]));
    PuneNr(R,nr,Rand);
    gets(Cuv);
    x=strlen(Cuv);
    for(int t=0; t<x; t++)
      assert(strchr(romane,Cuv[t]));
    PuneNr(C,nc,Cuv);

    for(i=1; i<=np; i++)
    {
        L[i].pg=P[i];
        L[i].rd=R[i];
        L[i].cv=C[i];

    }
    assert(np>=1&&np<=20);
    if(test==1){

     for(i=1; i<=np;i++) {
         printf("%d", L[i].pg);
         if(i<np) printf(" "); else printf("\n");
     }
     for(i=1; i<=np;i++) {
         printf("%d", L[i].rd);
         if(i<np) printf(" "); else printf("\n");
     }
     for(i=1; i<=np;i++) {
         printf("%d", L[i].cv);
         if(i<np) printf(" "); else printf("\n");
     }
    }
    else{

    scanf("%d %d %d\n", &p, &r, &c);
    assert(p>=1&&p<=2000&&r>=1&&r<=25&&c>=1&&c<=15);

    for(i=1; i<=np; i++)
    {
        assert(L[i].pg<=p && L[i].pg>=1);
        assert(test==1 || L[i].rd<=r && L[i].rd>=1);
        assert(test==1 || L[i].cv<=c && L[i].cv>=1);
    }
    sort(L + 1, L + np + 1, cmp);

    for(i=1; i<=p; i++)
        for(j=1; j<=r; j ++)
        {
            for(k=1; k<=c; k++)
            {
                scanf("%s", &s);
                x=strlen(s);
                assert(x<=12);
                for(int t=0; t<x; t++)
                  assert(isalpha(s[t])||s[t]==' ');
                if(L[ii].pg==i && L[ii].rd==j && L[ii].cv==k)
                {
                    if(ii<np)printf("%s ", s);
                    else printf("%s\n", s);
                    ii++;
                }
            }
            scanf("\n");
        }
    }
    return 0;
}

